<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ServiceTimesSelection_V2 StructType
 * @subpackage Structs
 */
class ServiceTimesSelection_V2 extends AbstractStructBase
{
    /**
     * The IncludeCoDrivers
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $IncludeCoDrivers;
    /**
     * The Drivers
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfIdentifier
     */
    public $Drivers;
    /**
     * The DateTimeRangeSelection
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DateTimeRangeSelection
     */
    public $DateTimeRangeSelection;
    /**
     * The DateTimeSelection
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DateTimeSelection
     */
    public $DateTimeSelection;
    /**
     * Constructor method for ServiceTimesSelection_V2
     * @uses ServiceTimesSelection_V2::setIncludeCoDrivers()
     * @uses ServiceTimesSelection_V2::setDrivers()
     * @uses ServiceTimesSelection_V2::setDateTimeRangeSelection()
     * @uses ServiceTimesSelection_V2::setDateTimeSelection()
     * @param bool $includeCoDrivers
     * @param \ArrayType\ArrayOfIdentifier $drivers
     * @param \StructType\DateTimeRangeSelection $dateTimeRangeSelection
     * @param \StructType\DateTimeSelection $dateTimeSelection
     */
    public function __construct($includeCoDrivers = null, \ArrayType\ArrayOfIdentifier $drivers = null, \StructType\DateTimeRangeSelection $dateTimeRangeSelection = null, \StructType\DateTimeSelection $dateTimeSelection = null)
    {
        $this
            ->setIncludeCoDrivers($includeCoDrivers)
            ->setDrivers($drivers)
            ->setDateTimeRangeSelection($dateTimeRangeSelection)
            ->setDateTimeSelection($dateTimeSelection);
    }
    /**
     * Get IncludeCoDrivers value
     * @return bool
     */
    public function getIncludeCoDrivers()
    {
        return $this->IncludeCoDrivers;
    }
    /**
     * Set IncludeCoDrivers value
     * @param bool $includeCoDrivers
     * @return \StructType\ServiceTimesSelection_V2
     */
    public function setIncludeCoDrivers($includeCoDrivers = null)
    {
        // validation for constraint: boolean
        if (!is_null($includeCoDrivers) && !is_bool($includeCoDrivers)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($includeCoDrivers, true), gettype($includeCoDrivers)), __LINE__);
        }
        $this->IncludeCoDrivers = $includeCoDrivers;
        return $this;
    }
    /**
     * Get Drivers value
     * @return \ArrayType\ArrayOfIdentifier|null
     */
    public function getDrivers()
    {
        return $this->Drivers;
    }
    /**
     * Set Drivers value
     * @param \ArrayType\ArrayOfIdentifier $drivers
     * @return \StructType\ServiceTimesSelection_V2
     */
    public function setDrivers(\ArrayType\ArrayOfIdentifier $drivers = null)
    {
        $this->Drivers = $drivers;
        return $this;
    }
    /**
     * Get DateTimeRangeSelection value
     * @return \StructType\DateTimeRangeSelection|null
     */
    public function getDateTimeRangeSelection()
    {
        return $this->DateTimeRangeSelection;
    }
    /**
     * Set DateTimeRangeSelection value
     * @param \StructType\DateTimeRangeSelection $dateTimeRangeSelection
     * @return \StructType\ServiceTimesSelection_V2
     */
    public function setDateTimeRangeSelection(\StructType\DateTimeRangeSelection $dateTimeRangeSelection = null)
    {
        $this->DateTimeRangeSelection = $dateTimeRangeSelection;
        return $this;
    }
    /**
     * Get DateTimeSelection value
     * @return \StructType\DateTimeSelection|null
     */
    public function getDateTimeSelection()
    {
        return $this->DateTimeSelection;
    }
    /**
     * Set DateTimeSelection value
     * @param \StructType\DateTimeSelection $dateTimeSelection
     * @return \StructType\ServiceTimesSelection_V2
     */
    public function setDateTimeSelection(\StructType\DateTimeSelection $dateTimeSelection = null)
    {
        $this->DateTimeSelection = $dateTimeSelection;
        return $this;
    }
}
